std::_Fwd_list_base< _Tp, _Alloc > Struct Template Reference

`#include <forward_list.h>`

Inheritance diagram for std::_Fwd_list_base< _Tp, _Alloc >:
[legend]

## Public Types

using | const_iterator
using | iterator
using | pointer

## Public Member Functions

| _Fwd_list_base (_Fwd_list_base &&)=default
| _Fwd_list_base (_Fwd_list_base &&__lst, _Node_alloc_type &&__a)
| _Fwd_list_base (_Fwd_list_base &&__lst, _Node_alloc_type &&__a, std::true_type)
| _Fwd_list_base (_Node_alloc_type &&__a)
const _Node_alloc_type & | _M_get_Node_allocator () const noexcept
_Node_alloc_type & | _M_get_Node_allocator () noexcept
template<typename... _Args>
auto | _M_insert_after (const_iterator __pos, _Args &&... __args) -> _Base_ptr

## Protected Types

using | _Base_ptr
using | _Node
using | _Node_alloc_traits
using | _Node_alloc_type
using | _Node_ptr
using | _Node_traits

## Protected Member Functions

template<typename... _Args>
_Node_ptr | _M_create_node (_Args &&... __args)
void | _M_destroy_node (_Node_ptr __p)
_Base_ptr | _M_erase_after (_Base_ptr __pos)
_Base_ptr | _M_erase_after (_Base_ptr __pos, _Base_ptr __last)
_Node * | _M_get_node ()
template<typename... _Args>
_Base_ptr | _M_insert_after (const_iterator __pos, _Args &&... __args)
void | _M_put_node (_Node_ptr __p)

## Protected Attributes

_Fwd_list_impl | _M_impl

## Detailed Description

template<typename _Tp, typename _Alloc>
struct std::_Fwd_list_base< _Tp, _Alloc >

Base class for forward_list.

Definition at line 600 of file forward_list.h.

## Member Typedef Documentation

## _Base_ptr

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Base_ptr

protected

Definition at line 617 of file forward_list.h.

## _Node

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Node

protected

Definition at line 613 of file forward_list.h.

## _Node_alloc_traits

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Node_alloc_traits

protected

Definition at line 615 of file forward_list.h.

## _Node_alloc_type

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Node_alloc_type

protected

Definition at line 614 of file forward_list.h.

## _Node_ptr

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Node_ptr

protected

Definition at line 616 of file forward_list.h.

## _Node_traits

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::_Node_traits

protected

Definition at line 612 of file forward_list.h.

## const_iterator

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::const_iterator

Definition at line 644 of file forward_list.h.

## iterator

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::iterator

Definition at line 643 of file forward_list.h.

## pointer

template<typename _Tp, typename _Alloc>

using std::_Fwd_list_base< _Tp, _Alloc >::pointer

Definition at line 604 of file forward_list.h.

## Constructor & Destructor Documentation

## _Fwd_list_base() [1/3]

template<typename _Tp, typename _Alloc>

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Node_alloc_type && | __a | ) |

inline

Definition at line 656 of file forward_list.h.

## _Fwd_list_base() [2/3]

template<typename _Tp, typename _Alloc>

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Fwd_list_base< _Tp, _Alloc > && | __lst,
|  | _Node_alloc_type && | __a,
|  | std::true_type | )

inline

Definition at line 660 of file forward_list.h.

## _Fwd_list_base() [3/3]

template<typename _Tp, typename _Alloc>

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Fwd_list_base< _Tp, _Alloc > && | __lst,
|  | _Node_alloc_type && | __a )

Definition at line 39 of file forward_list.tcc.

## ~_Fwd_list_base()

template<typename _Tp, typename _Alloc>

std::_Fwd_list_base< _Tp, _Alloc >::~_Fwd_list_base | ( |  | ) |

inline

Definition at line 670 of file forward_list.h.

## Member Function Documentation

## _M_create_node()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

_Node_ptr std::_Fwd_list_base< _Tp, _Alloc >::_M_create_node | ( | _Args &&... | __args | ) |

inline protected

Definition at line 698 of file forward_list.h.

## _M_destroy_node()

template<typename _Tp, typename _Alloc>

void std::_Fwd_list_base< _Tp, _Alloc >::_M_destroy_node | ( | _Node_ptr | __p | ) |

inline protected

Definition at line 715 of file forward_list.h.

## _M_get_node()

template<typename _Tp, typename _Alloc>

_Node * std::_Fwd_list_base< _Tp, _Alloc >::_M_get_node | ( |  | ) |

inline protected

Definition at line 677 of file forward_list.h.

## _M_get_Node_allocator() [1/2]

template<typename _Tp, typename _Alloc>

const _Node_alloc_type & std::_Fwd_list_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) | const

inline noexcept

Definition at line 651 of file forward_list.h.

## _M_get_Node_allocator() [2/2]

template<typename _Tp, typename _Alloc>

_Node_alloc_type & std::_Fwd_list_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) |

inline noexcept

Definition at line 647 of file forward_list.h.

## _M_insert_after()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

auto std::_Fwd_list_base< _Tp, _Alloc >::_M_insert_after | ( | const_iterator | __pos,
|  | _Args &&... | __args )->_Base_ptr

Definition at line 50 of file forward_list.tcc.

## _M_put_node()

template<typename _Tp, typename _Alloc>

void std::_Fwd_list_base< _Tp, _Alloc >::_M_put_node | ( | _Node_ptr | __p | ) |

inline protected

Definition at line 685 of file forward_list.h.

## Member Data Documentation

## _M_impl

template<typename _Tp, typename _Alloc>

_Fwd_list_impl std::_Fwd_list_base< _Tp, _Alloc >::_M_impl

protected

Definition at line 640 of file forward_list.h.

The documentation for this struct was generated from the following files:

- forward_list.h
- forward_list.tcc